unit Main;

interface

uses
  Windows, Messages, Graphics, Forms, Base, Classes, Grids,
  ExtCtrls, Controls, StdCtrls, ComCtrls, Buttons, iFont, Spin;

type
  TMainForm = class(TBaseForm)
    pgMain: TPageControl;
    Tab1: TTabSheet;
    Panel2: TPanel;
    lbFonts: TListBox;
    memMsg: TMemo;
    pnl1_1: TPanel;
    btnSortByName: TBitBtn;
    btnSortByStatus: TBitBtn;
    btnInsSel: TBitBtn;
    btnUnInsSel: TBitBtn;
    btnInsAll: TBitBtn;
    btnUnInsAll: TBitBtn;
    Tab2: TTabSheet;
    Panel1: TPanel;
    cmbFontName: TComboBox;
    spFontSize: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    memConverted: TMemo;
    Panel3: TPanel;
    editKana: TEdit;
    btnConvert: TBitBtn;
    Splitter4: TSplitter;
    btnClear: TBitBtn;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbFontsData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure lbFontsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure btnSortByNameClick(Sender: TObject);
    procedure btnSortByStatusClick(Sender: TObject);
    procedure btnInsSelClick(Sender: TObject);
    procedure btnUnInsSelClick(Sender: TObject);
    procedure btnInsAllClick(Sender: TObject);
    procedure btnUnInsAllClick(Sender: TObject);
    procedure pgMainChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cmbFontNameChange(Sender: TObject);
    procedure btnConvertClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnClearClick(Sender: TObject);
  private
    { Private 錾 }
	FBitmap01 	: TBitmap;
	FFontList	: TInstallFontList;

    EditPreProc	:TWndMethod;
    procedure	EditSubclassProc(var Msg: TMessage);
    function	GetIMECompString(CE: TCustomEdit; Index: DWORD):string;
    function	IsLastCharHiragana(s: string):Boolean;

    procedure	InitPage1();
    procedure	InitPage2();
    procedure	FontInstall(AFontIndex: integer);
    procedure	FontUnInstall(AFontIndex: integer);
  public
    { Public 錾 }
	procedure	DroppedAction(); override;
  end;

var
  MainForm: TMainForm;

implementation

uses
	iUtils, SysUtils, Math, Imm;

{$R *.dfm}

(* bZ[W\ *)
procedure	ShowInfo(Msg: string);
begin
	with MainForm.memMsg.Lines do
    begin
        if Count > 1000 then Clear;
		Add(Msg);
    end;
end;

(* RXgN^ *)
procedure	TMainForm.FormCreate(Sender: TObject);
begin
	inherited;
	InitPage1();
	InitPage2();
end;

(* fXgN^ *)
procedure	TMainForm.FormDestroy(Sender: TObject);
begin
    FBitmap01.Free;
    FFontList.SaveToFile();
	FFontList.Free;
	inherited;
end;

(* IO *)
procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
	inherited;
    ShowInfo('CXg[ĂtHg̓ACXg[܂B');
    Sleep(500);
end;

(*
	###########################

	1y[W

	###########################
*)

(*  *)
procedure	TMainForm.InitPage1();
begin
    FBitmap01 := TBitmap.Create;
	with FBitmap01 do
    begin
        Canvas.Font.Assign(Self.Font);
        Width := Screen.Width;
        Height := Screen.Height;
    end;

	FFontList := TInstallFontList.Create(ChangeFileExt(Application.ExeName, '.dat'));
    FFontList.LoadFromFile();
end;

(* tHgt@Chbv *)
procedure	TMainForm.DroppedAction();
var
	i: integer;
begin
	for i := 0 to DropFileList.Count - 1 do
    begin
        if CheckExtension(DropFileList[i], '.ttf') then
        begin
	    	FFontList.AddEx(TInstallFont.Create(DropFileList[i]));
        end;
    end;
    DropFileList.Clear;
	lbFonts.Count := FFontList.Count;
    lbFonts.Repaint;
	pgMain.ActivePageIndex := TTabSheet(lbFonts.Parent).TabIndex;
end;

(* tHgf[^\ *)
procedure TMainForm.lbFontsData(Control: TWinControl; Index: Integer;
  var Data: String);
begin
	Data := FFontList[Index].ToString;
end;

(* ` *)
procedure TMainForm.lbFontsDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    Text: string;
	OffsetX, OffsetY: integer;
begin
	with FBitmap01 do
    begin
        //hԂ̐F
        CanvasBrushColor(Canvas, State);
        //hԂ
        CanvasFillRect(Canvas, Rect);
        //f[^`
        Text := FFontList[Index].ToString;
        //ItZbgvZ
        OffsetX := 5;
        OffsetY := (lbFonts.ItemHeight - Canvas.TextHeight(Text)) div 2;
        CanvasTextOut(Canvas, OffsetX, OffsetY, Text);
        CanvasBitBlt(Canvas, lbFonts.Canvas, Rect);
    end;
end;

(* ̃\[g *)
procedure	TMainForm.btnSortByNameClick(Sender: TObject);
begin
	FFontList.SortEx(stName);
    lbFonts.Repaint;
end;

(* ԃ\[g *)
procedure TMainForm.btnSortByStatusClick(Sender: TObject);
begin
	FFontList.SortEx(stStatus);
    lbFonts.Repaint;
end;

(* tHgCXg[ *)
procedure	TMainForm.FontInstall(AFontIndex: integer);
var
	iFont: TInstallFont;
begin
    iFont := FFontList[AFontIndex];
    if iFont.Install then
        ShowInfo(Format('CXg[ >> %s', [iFont.FontName]))
    else
        ShowInfo(Format('CXg[s >> %s', [iFont.FontName]))
    ;
end;

(* tHgACXg[ *)
procedure	TMainForm.FontUnInstall(AFontIndex: integer);
var
	iFont: TInstallFont;
begin
    iFont := FFontList[AFontIndex];
    if iFont.Installed then
    begin
        iFont.UnInstall;
        ShowInfo(Format('ACXg[ >> %s', [iFont.FontName]))
    end;
end;

(* ItHgCXg[ *)
procedure TMainForm.btnInsSelClick(Sender: TObject);
var
	i: integer;
begin
	for i := 0 to FFontList.Count - 1 do
    begin
        if lbFonts.Selected[i] then
        begin
			FontInstall(i);
		    lbFonts.Repaint;
        end;
    end;
end;

(* ItHgACXg[ *)
procedure TMainForm.btnUnInsSelClick(Sender: TObject);
var
	i: integer;
begin
	for i := 0 to FFontList.Count - 1 do
    begin
        if lbFonts.Selected[i] then
        begin
			FontUnInstall(i);
		    lbFonts.Repaint;
        end;
    end;
end;

(* StHgCXg[ *)
procedure TMainForm.btnInsAllClick(Sender: TObject);
var
	i: integer;
begin
	for i := 0 to FFontList.Count - 1 do
    begin
        FontInstall(i);
        lbFonts.Repaint;
    end;
end;

(* StHgACXg[ *)
procedure TMainForm.btnUnInsAllClick(Sender: TObject);
var
	i: integer;
begin
	for i := 0 to FFontList.Count - 1 do
    begin
        FontUnInstall(i);
        lbFonts.Repaint;
    end;
end;

procedure TMainForm.btnClearClick(Sender: TObject);
begin
	ShowInfo('CXg[ĂtHg̓ACXg[܂B');
	FFontList.Clear;
	lbFonts.Count := FFontList.Count;
	lbFonts.Repaint;
end;

(*
	###########################

	2y[W

	###########################
*)

(*  *)
procedure	TMainForm.InitPage2();
begin
    EditPreProc := editKana.WindowProc;
    editKana.WindowProc := EditSubclassProc;
end;

(* tH[\̃tHg *)
procedure TMainForm.FormShow(Sender: TObject);
begin
	inherited;
	GetScreenFonts(cmbFontName.Items);
    cmbFontName.ItemIndex := 0;
end;

(* y[W؂ւ̃tHg *)
procedure TMainForm.pgMainChange(Sender: TObject);
begin
	case pgMain.ActivePageIndex of
    	1:
        begin
        	GetScreenFonts(cmbFontName.Items);
		    cmbFontName.ItemIndex := 0;
        end;
    end;
end;

(* tHgI *)
procedure TMainForm.cmbFontNameChange(Sender: TObject);
begin
	memConverted.Font.Name := cmbFontName.Items[cmbFontName.ItemIndex];
	try
	    memConverted.Font.Size := spFontSize.Value;
    except
		;
    end;
end;

(* ϊ *)
procedure TMainForm.btnConvertClick(Sender: TObject);
begin
	memConverted.Lines.Add(KanaToChars(editKana.Text));
end;

(* GfBbg{bNXTuNX *)
procedure	TMainForm.EditSubclassProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_IME_COMPOSITION) and (Msg.LParam = $1BF) then
    begin
        if IsLastCharHiragana(GetIMECompString(editKana, GCS_COMPSTR)) then
        begin
            keybd_event(VK_RETURN, 0, 0, 0);
            keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
        end;
    end;
    EditPreProc(Msg);
end;

(* Subject: [Delphi:74817] Re: ͂ꂽЂ炪ȂɊm肳@ *)
function	TMainForm.GetIMECompString(CE: TCustomEdit; Index: DWORD): string;
var
    hIM	:HIMC;
    PC	:PChar;
    Len	:Integer;
begin
    hIM := ImmGetContext(CE.Handle);
    Len := ImmGetCompositionString(hIM, Index, nil, 0);
    GetMem(PC, Len + 1);
    FillChar(PC^, Len+1, #0);
    ImmGetCompositionString(hIM, Index, PC, Len);
    Result := PC;
    FreeMem(PC);
    ImmReleaseContext(CE.Handle, hIM);
end;

(* ǂ̔ *)
function	TMainForm.IsLastCharHiragana(s: string):Boolean;
var
    i, Len:integer;
    Ws:WideString;
begin
    Ws := s;
    Len := Length(Ws);
    result := True;
    for i := 1 to Len do
    begin
        if (Ord(Ws[i]) < $3040) or (Ord(Ws[i]) > $309F) then
        begin
            Result := False;
            Exit;
        end;
    end;
end;

end.
